<?lsp

local NUMBER_OF_QUESTIONS    = 6
local NUMBER_OF_GIFS_IN_COL  = 4
local NUMBER_OF_GIFS_IN_ROW  = 4

local fmt = string.format
local Question = {}
local random = rnd or math.random

Question[1] = function()
   return "<P>Bill Clinton was born on August 19.<BR>"..
      "What's his sign?</P>"..
      "<SELECT NAME=\"guess\">"..
      "    <OPTION>Aries</OPTION>"..
      "    <OPTION>Taurus</OPTION>"..
      "    <OPTION>Gemini</OPTION>"..
      "    <OPTION>Cancer</OPTION>"..
      "    <OPTION>Leo</OPTION>"..
      "    <OPTION>Virgo</OPTION>"..
      "    <OPTION>Libra</OPTION>"..
      "    <OPTION>Scorpio</OPTION>"..
      "    <OPTION>Saggitarius</OPTION>"..
      "    <OPTION>Capricorn</OPTION>"..
      "    <OPTION>Aquarius</OPTION>"..
      "    <OPTION>Pisces</OPTION>"..
      "</SELECT>\n"..
      "<INPUT TYPE=\"HIDDEN\" NAME=\"answer\" VALUE=\"Leo\">\n"
end


Question[2] = function()
   return "<P>What is the capital of Spain?</P>\n"..
      "<INPUT TYPE=\"TEXT\" LENGTH=20 NAME=\"guess\">"..
      "<INPUT TYPE=\"HIDDEN\" NAME=\"answer\" VALUE=\"Madrid\">\n"
end

Question[3] =  function()
   return
    "Which of the following is closest to the North Pole?</P>\n"..
    "<INPUT TYPE=\"radio\" NAME=\"guess\" VALUE=\"Berlin\">"..
    "Berlin<BR>\n"..
    "<INPUT TYPE=\"radio\" NAME=\"guess\" VALUE=\"Ottawa\">"..
    "Ottawa<BR>\n"..
    "<INPUT TYPE=\"radio\" NAME=\"guess\" VALUE=\"Lisbon\">"..
    "Lisbon<BR>\n"..
    "<INPUT TYPE=\"radio\" NAME=\"guess\" VALUE=\"Tokyo\">"..
    "Tokyo<BR>\n"..
    "<INPUT TYPE=\"HIDDEN\" NAME=\"answer\" VALUE=\"Berlin\">\n"
end


Question[4] = function()
 local month, monthNames =
 os.date("*t").month,
 {  "January",     "February",       "March",       "April",
                  "May",         "June",           "July",        "August",
                  "September",   "October",        "November",    "December"  }

  local list = "<P>What month is it?</P>\n<SELECT NAME=\"guess\">\n"
  for _,v in ipairs(monthNames) do
     list = list .. "   <OPTION>" .. v .. "</OPTION>\n"
  end
  list = list .. "</SELECT>\n"
  list = list .. fmt("<INPUT TYPE=\"HIDDEN\" NAME=\"answer\" VALUE=\"%s\">\n", monthNames[month])
  return list
end


local function get_gif()
  return ({
    {name = "images/apple.gif", width = "33", height = "41", alt = "apple",},
    {name="images/bird.gif",width="156",height="67",alt="bird",},
    {name="images/flower.gif",width="50",height="91",alt="flower",},
    {name="images/clock.gif",width="54",height="53",alt="clock",},
    {name="images/lightbul.gif",width="39",height="75",alt="lightbulb",},
   })[random(5)]
end

local function GetThingToBeCounted()
    return ({"apple", "bird", "flower", "clock", "lightbulb"})[random(5)]
end


Question[5] = function()
   local MAX_GIF_WIDTH  = 99
   local MAX_GIF_HEIGHT = 91

   local gif = {}
   local objectcount = {}

   local fulltext = fmt("<TABLE WIDTH=%d CELLPADDING=0 CELLSPACING=0 BORDER = 0>",
        NUMBER_OF_GIFS_IN_ROW * MAX_GIF_WIDTH)

   local x = 0
   while x < NUMBER_OF_GIFS_IN_ROW * NUMBER_OF_GIFS_IN_COL do
      x = x + 1
      gif[x] = get_gif()
      objectcount[gif[x].alt] = (objectcount[gif[x].alt] or 0) + 1

      --format <IMG> tags with hanging indent to make the
      --HTML code easier to read

      if x % NUMBER_OF_GIFS_IN_ROW == 0 then
         fulltext = fulltext..fmt("<TR HEIGHT=%d>",MAX_GIF_HEIGHT)
      end
      fulltext = fulltext..fmt("<TD VALIGN=CENTER ALIGN=CENTER WIDTH=%d>",MAX_GIF_WIDTH)
      fulltext = fulltext..fmt("<IMG SRC=\"%s\" WIDTH=%s HEIGHT=%s ALT=\"%s\">",
                               gif[x].name, gif[x].width, gif[x].height, gif[x].alt)
      fulltext = fulltext ..  "</TD>\n"
      if  x % NUMBER_OF_GIFS_IN_ROW == NUMBER_OF_GIFS_IN_ROW-1 then
         fulltext = fulltext ..  "</TR>\n";
      end
   end

   fulltext = fulltext ..  "</TABLE>\n"

   local thingToBeCounted = GetThingToBeCounted()

   fulltext = fulltext..fmt("<H3>How many %ss are there in this picture?</H3>", thingToBeCounted)
   fulltext = fulltext ..  "<INPUT TYPE=\"TEXT\" SIZE=5 NAME=\"guess\"><BR>\n"
   fulltext = fulltext..fmt("<INPUT TYPE=\"HIDDEN\" NAME=\"answer\" VALUE=%d>\n",
    objectcount[thingToBeCounted])
   return fulltext
end

Question[6] = function()
   return
      "Who does not belong</P>\n"..
      "<INPUT TYPE=\"radio\" NAME=\"guess\" VALUE=\"Stone\">"..
      "Sharon Stone<BR>\n"..
      "<INPUT TYPE=\"radio\" NAME=\"guess\" VALUE=\"Pfeiffer\">"..
      "Michele Pfeiffer<BR>\n"..
      "<INPUT TYPE=\"radio\" NAME=\"guess\" VALUE=\"Madonna\">"..
      "Madonna<BR>\n"..
      "<INPUT TYPE=\"radio\" NAME=\"guess\" VALUE=\"Franklin\">"..
      "Benjamin Franklin<BR>\n"..
      "<INPUT TYPE=\"HIDDEN\" NAME=\"answer\" VALUE=\"Franklin\">\n"
end

title="elephant"
response:include"/rtl/.header.lsp"
?>
     <FORM METHOD="POST">
        <P>
           We can't have just anybody going around looking at the elephant. <BR>
           To make sure you have what it takes, answer the following question:
        </P>
        <P>
           <?lsp
  		      local questionnbr
			  repeat
  		        questionnbr = random(NUMBER_OF_QUESTIONS)
			  until questionnbr ~= page.lastquestion
			  page.lastquestion = questionnbr
              response:write(  Question[questionnbr]()  )
           ?>
        </P>
        <INPUT TYPE="SUBMIT">
     </FORM>
<?lsp response:include"/rtl/.footer.lsp" ?>
